package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.BaseLevel;
import com.ruoyi.web.base.service.IBaseLevelService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-03
 */
@RestController
@RequestMapping("/base-level")
public class BaseLevelController {
    @Autowired
    private IBaseLevelService baseLevelService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("级别管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody BaseLevel baseLevel, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseLevelService.count(new QueryWrapper<BaseLevel>().eq("org_id",loginOrgId).eq("level_no", baseLevel.getLevelName())) >0 ){
            throw new Exception("该编号已存在");
        }

        baseLevel.setOrgId(loginOrgId);
        baseLevel.setCreateBy(getUsername());
        return success(baseLevelService.save(baseLevel));
    }

    @ApiOperation("级别管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody BaseLevel baseLevel, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseLevelService.count(new QueryWrapper<BaseLevel>().ne("id",baseLevel.getId()).eq("org_id",loginOrgId).eq("level_no", baseLevel.getLevelName())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseLevel.setUpdateBy(getUsername());
        return success(baseLevelService.updateById(baseLevel));
    }

    @ApiOperation("级别管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            baseLevelService.removeById(s);
        }
        return success();
    }

    @ApiOperation("级别管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( HttpServletRequest request){
        return success(baseLevelService.list(new QueryWrapper<BaseLevel>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("级别管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize,HttpServletRequest request
    ) {
        return success(baseLevelService.page(new Page<BaseLevel>(pageNum,pageSize),new QueryWrapper<BaseLevel>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("级别管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(baseLevelService.getById(id));
    }
}
